#ifndef _gIIePad_
#define _gIIePad_

class gIIePad 
{
public:
	typedef void (*callbackfunction)(long abs_x, long abs_y, long pressure, unsigned char fTouch, unsigned char fTap, long buttonState, unsigned long dwTimeStamp, unsigned long dwSequenceNum );

private:
	typedef struct {
		char classID[33];
		char description[64];
	} ProviderInfo;
	
	ProviderInfo m_providerArray[10];
	int m_providerArrayCount;
	int m_currentProvider;
	callbackfunction m_EventHandler;
	
	int m_minx, m_miny, m_minp;
	int m_maxx, m_maxy, m_maxp;

public:
		gIIePad();
		virtual ~gIIePad();
		virtual void CloseConnection();
		virtual bool OpenConnection();
		virtual short GetNumProviders();
		virtual char * GetProviderClassID(short index);
		virtual char * GetProviderDescription(short index);
		virtual void SetProviderDescription(char *classId, char * description);
		virtual bool OpenProvider(char *classid);
		virtual void CloseProvider();
		virtual long SetDebugParam(char *key, char *value);
		virtual char * GetDebugParam(char *key);
		virtual short GetNumDevices();
		virtual char *ConnGetSerialNumber();
		virtual long ConnGetDataRangeMinX();
		virtual long ConnGetDataRangeMinY();
		virtual long ConnGetDataRangeMinZ();
		virtual long ConnGetDataRangeMaxX();
		virtual long ConnGetDataRangeMaxY();
		virtual long ConnGetDataRangeMaxZ();
		virtual short ConnGetNumButtons();
		virtual double ConnGetPhysicalX();
		virtual double ConnGetPhysicalY();
		virtual char * EnumSerialNumberHistory(short index);
		virtual long SetDebugParamEx( char * instra, char instrb);
		virtual bool RegisterEventHandler(callbackfunction ptrfn);
};
#endif